
type fmt = string

external pack            : fmt -> 'a -> bytes = "ocaml_pack_generic"
external unpack_internal : fmt -> pos:int -> bytes -> 'a = "ocaml_unpack_generic"

let unpack fmt ?(pos=0) buf = unpack_internal fmt ~pos buf
let unpack_int32 ?(pos=0) buf = !(unpack_internal "i" ~pos buf : int32 ref)
let unpack_int64 ?(pos=0) buf = !(unpack_internal "l" ~pos buf : int64 ref)

